using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace TcpServerTester
{
    public partial class TcpServerTester : Form
    {
        #region ⏕NXA錾

        //log4net̐錾
        private static readonly log4net.ILog logger = 
            log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        /// <summary>
        /// XbhĂяo֐ŁAe`B
        /// </summary>
        public enum CallbackAction
        {
            AddLogString,
            FormInitialise
        }

        private Socket soc;       // NCAg\Pbg̊Ǘp\Pbgz

        delegate void SetCallBack(CallbackAction actCode, Socket soc, string msg);

        #endregion

        #region CxgEȂ

        /// <summary>
        /// RXgN^
        /// {^LE̒A|[gԍ̓Ǎ
        /// </summary>
        public TcpServerTester()
        {
            // tH[ERg[̐錾
            InitializeComponent();

            // tH[̑ԂOnɂB
            this.operate(false);

            // DataGridView̃JEs̃Zbg
            try
            {
                this.dgvList.RowCount = Properties.Settings.Default.MAX_ROW;
                this.dgvList.ColumnCount = Properties.Settings.Default.MAX_COLUMN;
                for (int i = 0; i < this.dgvList.ColumnCount; i++)
                {
                    this.dgvList.Columns[i].Width = 35;
                    this.dgvList.Columns[i].HeaderText = (i + 1).ToString();
                }
                this.dgvList.CurrentCell = this.dgvList.Rows[0].Cells[0];
            }
            catch
            {
                MessageBox.Show("RtBOt@ĆAősEő񐔂̎w肪傫܂B",
                    this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                this.Close();
            }

            // ̓Rg[ɏlZbgB
            this.numPort.Value = Properties.Settings.Default.TCP_PORT;
            this.txtIP.Text = Properties.Settings.Default.IP_ADDRESS;
            this.pasteDate(Properties.Settings.Default.RESULT_DATA);
        }

        /// <summary>
        /// uڑv{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdConnect_Click(object sender, EventArgs e)
        {
            this.connect();
        }

        /// <summary>
        /// uؒfv{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdClose_Click(object sender, EventArgs e)
        {
            if (this.soc != null)
            {
                this.soc.Close();
            }
            operate(false);

            this.execRootThread(CallbackAction.AddLogString, null, "ؒf܂B");
        }

        /// <summary>
        /// uf[^Mv{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdSend_Click(object sender, EventArgs e)
        {
            this.sendData();
        }

        /// <summary>
        /// {^E|[gԍ̓Rg[̗LEݒ
        /// </summary>
        /// <param name="bStarted"></param>
        private void operate(bool bStarted)
        {
            this.numPort.Enabled = !bStarted;
            this.txtIP.Enabled = !bStarted;
            this.cmdConnect.Enabled = !bStarted;
            this.cmdClose.Enabled = bStarted;
            this.cmdSend.Enabled = bStarted;
        }

        /// <summary>
        /// Rg[̃f[^ۑB
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TcpServerTester_FormClosing(object sender, FormClosingEventArgs e)
        {
            string sData = "";
            for (int iRow = 0; iRow < this.dgvList.RowCount; iRow++)
            {
                if (this.dgvList.Rows[iRow].Cells[0].Value == null) { break; }

                for (int iCol = 0; iCol < this.dgvList.ColumnCount; iCol++)
                {
                    if (this.dgvList.Rows[iRow].Cells[iCol].Value != null)
                    {
                        sData += this.dgvList.Rows[iRow].Cells[iCol].Value.ToString() + "\t";
                    }
                    else
                    {
                        sData += "\r\n";
                        break;
                    }
                }
            }
            Properties.Settings.Default.TCP_PORT = (int)this.numPort.Value;
            Properties.Settings.Default.RESULT_DATA = sData;
            Properties.Settings.Default.IP_ADDRESS = this.txtIP.Text;
            Properties.Settings.Default.Save();
        }

        /// <summary>
        /// DataGridView֍sԍ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvList_CellPainting(object sender, DataGridViewCellPaintingEventArgs e)
        {
            //wb_[ǂׂ
            if (e.ColumnIndex < 0 && e.RowIndex >= 0)
            {
                //Z`悷
                e.Paint(e.ClipBounds, DataGridViewPaintParts.All);

                //sԍ`悷͈͂肷
                //e.AdvancedBorderStylee.CellStyle.Padding͖Ă܂
                Rectangle indexRect = e.CellBounds;
                indexRect.Inflate(-2, -2);
                //sԍ`悷
                TextRenderer.DrawText(e.Graphics,
                    (e.RowIndex + 1).ToString(),
                    e.CellStyle.Font,
                    indexRect,
                    e.CellStyle.ForeColor,
                    TextFormatFlags.Right | TextFormatFlags.VerticalCenter);
                //`悪Ƃm点
                e.Handled = true;
            }
        }

        /// <summary>
        /// uCtrl + VvL[ŁANbv{[h^u؂蕶\t
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvList_KeyDown(object sender, KeyEventArgs e)
        {
            if ((e.Control) && (e.KeyCode == Keys.V))
            {
                //Nbv{[h̓e擾āAsŕ
                this.pasteDate(Clipboard.GetText());
            }

            if (e.KeyCode == Keys.Delete)
            {
                for (int i = 0; i < this.dgvList.SelectedCells.Count; i++)
                {
                    this.dgvList.SelectedCells[i].Value = null;
                }
            }

            if ((e.Control) && (e.KeyCode == Keys.Right))
            {
                int iCol;
                for (iCol = this.dgvList.CurrentCell.ColumnIndex; iCol < this.dgvList.ColumnCount; iCol++)
                {
                    if (this.dgvList.Rows[this.dgvList.CurrentCell.RowIndex].Cells[iCol].Value == null) { break; }
                    if (this.dgvList.Rows[this.dgvList.CurrentCell.RowIndex].Cells[iCol].Value.ToString().Length == 0) { break; }
                }
                if (iCol >= this.dgvList.ColumnCount) { iCol = this.dgvList.ColumnCount - 1; }
                this.dgvList.CurrentCell = this.dgvList.Rows[this.dgvList.CurrentCell.RowIndex].Cells[iCol];
                e.SuppressKeyPress = true;
            }

            if ((e.Control) && (e.KeyCode == Keys.Down))
            {
                int iRow;
                for (iRow = this.dgvList.CurrentCell.RowIndex; iRow < this.dgvList.RowCount; iRow++)
                {
                    if (this.dgvList.Rows[iRow].Cells[0].Value == null) { break; }
                    if (this.dgvList.Rows[iRow].Cells[0].Value.ToString().Length == 0) { break; }
                }
                if (iRow >= this.dgvList.RowCount) { iRow = this.dgvList.RowCount - 1; }
                this.dgvList.CurrentCell = this.dgvList.Rows[iRow].Cells[this.dgvList.CurrentCell.ColumnIndex];
                e.SuppressKeyPress = true;
            }
        }

        /// <summary>
        /// DataGridViewւ͎̓A16iłȂ͍̂폜B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvList_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            if ((e.RowIndex <= -1) || (e.ColumnIndex <= -1)) { return; }
            if (this.dgvList.Rows[e.RowIndex].Cells[e.ColumnIndex].Value == null) { return; }

            string cellValue = this.dgvList.Rows[e.RowIndex].Cells[e.ColumnIndex].Value.ToString();
            int byteValue;
            try
            {
                byteValue = Convert.ToInt16(cellValue, 16);
            }
            catch
            {
                this.dgvList.Rows[e.RowIndex].Cells[e.ColumnIndex].Value = "";
            }

        }

        /// <summary>
        /// ݒ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmdConfig_Click(object sender, EventArgs e)
        {
            ConfigForm frm = new ConfigForm();
            frm.ShowDialog();
        }

        #endregion

        #region TCPNCAg

        /// <summary>
        /// TCPڑJnB
        /// </summary>
        private void connect()
        {
            byte[] bIp = new byte[4];

            //IPAhX̓̓`FbN
            if (!this.check_input(bIp)) { return; }
            try
            {
                IPAddress hostAdd = new IPAddress(bIp);
                IPEndPoint hostEp = new IPEndPoint(hostAdd, (int)this.numPort.Value);
                this.soc = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                this.soc.Connect(hostEp);

                ClientSoc so = new ClientSoc(this.soc);

                //񓯊̎MJn
                // jf[^M֐urec_Datav́A{̂ƕʃXbhœ삷B
                this.soc.BeginReceive(so.ReceiveBuffer,
                                    0,
                                    so.ReceiveBuffer.Length,
                                    SocketFlags.None,
                                    new System.AsyncCallback(rec_Data),
                                    so);

                //ʕ\̕ύX
                operate(true);
                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[oIPAhXF" + this.txtIP.Text + " ֐ڑ܂B");
            }
            catch
            {
                operate(false);
                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[oIPAhXF" + this.txtIP.Text + " ւ́AڑɎs܂B");
            }
        }

        /// <summary>
        /// ڑO̓̓`FbN
        /// </summary>
        /// <returns></returns>
        private bool check_input(byte[] bIp)
        {
            // IPAhX͗p̃eLXg{bNXɂāA󔒂폜B
            this.txtIP.Text = this.txtIP.Text.Replace(" ", "").Replace("@", "");

            // IPAhX̃tH[}bg`FbNpϐ
            string[] tmpStr = this.txtIP.Text.Split('.');
            int[] tmpIp = new int[4];

            // u.vŋ؂ꂽp[gv4邱ƂmFB
            if (tmpStr.Length != 4)
            {
                MessageBox.Show("ݒP^uAuMC IPAhXvڂ́Au.v(_)ŋ؂S̐l͂ĉB",
                                this.Text,
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Exclamation);
                return false;
            }

            // 4̃p[gꂼꐔlł邱ƂmFB
            for (int i = 0; i < 4; i++)
            {
                if (!int.TryParse(tmpStr[i], out tmpIp[i]))
                {
                    MessageBox.Show("ݒP^uAuMC IPAhXvڂ̏słB",
                        this.Text,
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Exclamation);
                    return false;
                }
                else
                {
                    bIp[i] = (byte)tmpIp[i];
                }
            }
            return true;
        }

        /// <summary>
        /// NCAgf[^󂯎Ƃ̏
        /// </summary>
        /// <param name="ar"></param>
        private void rec_Data(System.IAsyncResult ar)
        {
            //ԃIuWFNg̎擾
            ClientSoc so = (ClientSoc)ar.AsyncState;
            byte[] revByte = null;

            //ǂݍ񂾒擾
            int len = 0;
            try
            {
                len = so.Socket.EndReceive(ar);
            }
            catch (System.ObjectDisposedException)
            {
                this.execRootThread(CallbackAction.AddLogString, null,
                    "NCAgڑؒf܂B");

                so.Socket.Close();
                this.execRootThread(CallbackAction.FormInitialise, null, "");

                return;
            }
            catch (Exception)
            {
                len = 0;
            }

            //ؒfꂽׂ
            if (len <= 0)
            {
                this.execRootThread(CallbackAction.AddLogString, null, 
                    "T[oF " + ((IPEndPoint)so.Socket.RemoteEndPoint).Address.ToString() + "ؒf܂B");

                so.Socket.Close();
                this.execRootThread(CallbackAction.FormInitialise, null, "");

                return;
            }

            //Mf[^~ς
            so.ReceivedData.Write(so.ReceiveBuffer, 0, len);
            if (so.Socket.Available == 0)
            {
                //Ō܂ŎMAMf[^oCgzփZbgB
                revByte = so.ReceivedData.ToArray();
                
                //NCAg\PbgpIuWFNǵAobt@NAB
                so.ReceivedData.Close();
                so.ReceivedData = new System.IO.MemoryStream();
            }

            if (revByte != null) 
            {
                // Oo
                this.execRootThread(CallbackAction.AddLogString, null, 
                    "T[oF "  + ((IPEndPoint)so.Socket.RemoteEndPoint).Address.ToString() + "f[^M܂Bu"
                        + ByteArrayUtil.GetHexStrByByteArray(revByte, 0, (revByte.Length - 1)) + "v");
            }
            //ĂюMJn
            try
            {
                so.Socket.BeginReceive(so.ReceiveBuffer,
                                        0,
                                        so.ReceiveBuffer.Length,
                                        SocketFlags.None,
                                        new System.AsyncCallback(rec_Data),
                                        so);
            }
            catch
            {
                //RSTtOɂؒfABeginRecievesB
                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[oF " + ((IPEndPoint)so.Socket.RemoteEndPoint).Address.ToString() + "ؒf܂B");

                so.Socket.Close();
                this.execRootThread(CallbackAction.FormInitialise, null, "");
            }
        }

        /// <summary>
        /// T[oփf[^𑗐MB
        /// </summary>
        private void sendData()
        {
            int iColCount = 0;
            int iRowIndex = this.dgvList.CurrentCell.RowIndex;
            byte[] sendByte;

            if (this.soc == null)
            {
                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[o֐ڑĂ܂B");
                return;
            }

            if (!this.soc.Connected)
            {
                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[o֐ڑĂ܂B");
                return;
            }

            // XvbhV[g̍ŉsɓBƂAf[^𑗐MȂB
            if ((iRowIndex + 1) >= this.dgvList.RowCount)
            {
                this.execRootThread(CallbackAction.AddLogString, null,
                    "XvbhV[g̍ős𒴂܂Bȏf[^𑗐Mł܂B");
                return;
            }

            // XvbhV[g̃JgsŁA͍ς݃ZJEgB
            for (int i = 0; i < this.dgvList.ColumnCount; i++)
            {
                if (this.dgvList.Rows[iRowIndex].Cells[i].Value == null)
                {
                    iColCount = i;
                    break;
                }
                if (this.dgvList.Rows[iRowIndex].Cells[i].Value.ToString().Trim().Length == 0)
                {
                    iColCount = i;
                    break;
                }
            }

            // Zf[^͂ĂȂƂAf[^𑗐MȂB
            if (iColCount == 0)
            {
                this.execRootThread(CallbackAction.AddLogString, null,
                    "Mf[^܂B");
                return;
            }
            else
            {
                // f[^ƂAf[^𑗐M
                // f[^Bytez񉻂B
                sendByte = new byte[iColCount];
                for (int i = 0; i < iColCount; i++)
                {
                    sendByte[i] = ByteArrayUtil.GetByteByHexStr(this.dgvList.Rows[iRowIndex].Cells[i].Value.ToString().Trim());
                }

                this.soc.Send(sendByte);

                this.execRootThread(CallbackAction.AddLogString, null,
                    "T[oF " + ((IPEndPoint)soc.RemoteEndPoint).Address.ToString()
                    + "ցAf[^𑗐M܂Bu" + ByteArrayUtil.GetHexStrByByteArray(sendByte, 0, (iColCount - 1)) + "v");
            }
            iRowIndex++;
            this.dgvList.CurrentCell = this.dgvList.Rows[iRowIndex].Cells[0];
        }

        /// <summary>
        /// eXbhōs
        /// </summary>
        /// <param name="actCode"></param>
        /// <param name="soc"></param>
        /// <param name="msg"></param>
        private void execRootThread(CallbackAction actCode, Socket soc, string msg)
        {
            if (this.InvokeRequired)
            {
                SetCallBack setCallBack = new SetCallBack(execRootThread);
                this.Invoke(setCallBack, new object[] { actCode, soc, msg });
            }
            else
            {
                switch (actCode)
                {
                    // Oۑ
                    case CallbackAction.AddLogString:     
                        logger.Debug(msg);
                        string bText = DateTime.Now.ToString() + "  :" + msg + "\r\n" + this.txtStatus.Text;
                        if (bText.Length > this.txtStatus.MaxLength) { bText = bText.Substring(0, this.txtStatus.MaxLength); }
                        this.txtStatus.Text = bText;
                        break;

                    case CallbackAction.FormInitialise:
                        this.operate(false);
                        break;
                }
            }
        }

        /// <summary>
        /// DataGridViewցAeLXgf[^\tB
        /// </summary>
        /// <param name="sData"></param>
        private void pasteDate(string sData)
        {
            //݂̃Ẑs牺Ƀy[Xg
            if (this.dgvList.CurrentCell == null)
                return;
            int insertRowIndex = this.dgvList.CurrentCell.RowIndex;
            int insertColIndex = this.dgvList.CurrentCell.ColumnIndex;

            //Nbv{[h̓e擾āAsŕ
            string pasteText = sData;
            if (string.IsNullOrEmpty(pasteText))
                return;
            pasteText = pasteText.Replace("\r\n", "\n");
            pasteText = pasteText.Replace('\r', '\n');
            pasteText.TrimEnd(new char[] { '\n' });
            string[] lines = pasteText.Split('\n');

            foreach (string line in lines)
            {
                //^uŕ
                string sTmpLine = line.Replace("-", "\t").Replace(":", "\t").Replace(" ", "\t");
                string[] vals = sTmpLine.Split('\t');

                //sf[^́AeXVȂB
                if ((vals.Length == 1) && (vals[0].Length == 0)) { continue; }

                DataGridViewRow row = this.dgvList.Rows[insertRowIndex];

                //eZ̒lݒ
                for (int i = insertColIndex; i < (vals.Length + insertColIndex); i++)
                {
                    if (i >= this.dgvList.ColumnCount) { continue; }
                    if (vals[i - insertColIndex].Length == 0)
                    {
                        row.Cells[i].Value = null;
                    }
                    else
                    {
                        row.Cells[i].Value = vals[i - insertColIndex];
                    }
                }
                //̍s
                insertRowIndex++;

                //̍sA[JnʒuɂƂB
                //insertColIndex = 0;
            }
        }

        #endregion

    }
}